<?php
function fn_lag_mc($aql)
{	
	$list = $aql->Consume(2);
	$plist = array();
	
	$map = $list[1]->value;	
	$lagamount = $list[0]->value;		
	
	if (count($map) == 0)
	{		
		array_push($aql->stack,$list[1]);
		return;
	}
		
	if (isset($map['start']))
	{
		$datestart = DateTimeImmutable::createFromFormat("Y-m-d H:i:s",$map['start'],new DateTimeZone('UTC'));
		$dateend = DateTimeImmutable::createFromFormat("Y-m-d H:i:s",$map['end'],new DateTimeZone('UTC'));
	}
	else
	{
		if (isset($map['range']))
		{
			$dateend = DateTimeImmutable::createFromFormat("Y-m-d H:i:s",date("Y-m-d H:i:s"),new DateTimeZone('UTC'));			
			$range = DateInterval::createFromDateString($map['range']);				
			$datestart = $dateend->sub($range);
		}
	}
	
	if (isset($datestart))
	{
		if (is_array($lagamount))
		{
			$lagamount = intval($lagamount[array_keys($lagamount)[0]]);
		}		
		if ($lagamount > 0)
		{
			$diff = new DateInterval('PT'.abs($lagamount).'S');
			$datestart = $datestart->sub($diff);
			$dateend = $dateend->sub($diff);			
		}
		else
		{
			$diff = new DateInterval('PT'.abs($lagamount).'S');
			$datestart = $datestart->add($diff);
			$dateend = $dateend->add($diff);			
		}
		
		if (isset($map['range'])) unset($map['range']);
		$map['start'] = $datestart->format("Y-m-d H:i:s");
		$map['end'] = $dateend->format("Y-m-d H:i:s");
		
		$list[1]->value = $map;
	}
		
	array_push($aql->stack,$list[1]);
	return;

}

function fn_lag_mt($aql)
{	
	$list = $aql->Consume(2);
	$plist = array();
	
	$map = $list[1]->value;	
	$lagamount = $list[0]->value;
	if (!is_array($lagamount))
	{
		$lagamount = array($lagamount);
	}
	
	if (count($lagamount) > 0)
	{
		if ($lagamount[0]->dynamic == "")
		{
			LiveValuesForPoints($lagamount);
		}
	}
			
	$lagamount = $lagamount[0];	
	$lagamount = $lagamount->rawvalue;
	
	if (count($map) == 0)
	{		
		array_push($aql->stack,$list[1]);
		return;
	}
		
	if (isset($map['start']))
	{
		$datestart = DateTimeImmutable::createFromFormat("Y-m-d H:i:s",$map['start'],new DateTimeZone('UTC'));
		$dateend = DateTimeImmutable::createFromFormat("Y-m-d H:i:s",$map['end'],new DateTimeZone('UTC'));
	}
	else
	{
		if (isset($map['range']))
		{
			$dateend = DateTimeImmutable::createFromFormat("Y-m-d H:i:s",date("Y-m-d H:i:s"),new DateTimeZone('UTC'));			
			$range = DateInterval::createFromDateString($map['range']);				
			$datestart = $dateend->sub($range);
		}
	}
	
	if (isset($datestart))
	{
		if (is_array($lagamount))
		{
			$lagamount = intval($lagamount[array_keys($lagamount)[0]]);
		}		
		if ($lagamount > 0)
		{
			$diff = new DateInterval('PT'.abs($lagamount).'S');
			$datestart = $datestart->sub($diff);
			$dateend = $dateend->sub($diff);			
		}
		else
		{
			$diff = new DateInterval('PT'.abs($lagamount).'S');
			$datestart = $datestart->add($diff);
			$dateend = $dateend->add($diff);			
		}
		
		if (isset($map['range'])) unset($map['range']);
		$map['start'] = $datestart->format("Y-m-d H:i:s");
		$map['end'] = $dateend->format("Y-m-d H:i:s");
		
		$list[1]->value = $map;
	}
		
	array_push($aql->stack,$list[1]);
	return;

}
?>