<?php

require_once($installfolder.'/model/property.php');
require_once($installfolder.'/model/relationship.php');

global $db;

if (isset($_REQUEST['value']))
{
	header('Location: '.$siteroot.'/treemapper/map?value='.$_REQUEST['value'].'&perspective='.$_REQUEST['persp']);
	exit();
}

$path = $sitefolder.'/addons';
if (!file_exists($path))
{
	mkdir($path);
}

$validprops = [];

$query = $db->query("SELECT propertyid,COUNT(*) as cnt FROM datalinks WHERE mode=0 GROUP BY propertyid");
					
while($row = $query->fetch(PDO::FETCH_ASSOC)) 
{
	$validprops[] = $row['propertyid'];
}

$props = Properties::GetAllProperties();

$rels = Relationships::GetAllRelationships();

$title = "Tree-Mapping";

include($installfolder.'/include/tmpl.php');

ST('section','class=content');
	ST('row');
		ST('full');
			ST('boxform','title=Tree-Mapping');?>
        
				<!--<br/><button type="submit" href="<?php echo $siteroot;?>" class="btn btn-success" style="display: none;">Begin Analysis</a>--><?php										
					?>
					<h3>Select a Value:</h3>					
					<select name="value">
					<?php
					$options = array();
					$perspectives = array();
					foreach($props as $px)
					{
						if (!in_array($px->id,$validprops)) continue;
						if (($px->type == "ENUM") || ($px->type == "STATUS") || ($px->type == "LOOKUP") || ($px->type == "TEXT")) {
							$options[$px->name] = $px;
							$perspectives[$px->name] = $px;
						}
						if ($px->type == "MEASUREMENT") 
						{
							$options[$px->name] = $px;							
						}
					}						
					
					ksort($options);
					
					foreach($options as $k => $v)
					{
						echo '<option value="'.$v->id.'">'.$k.'</option>';
					}
					
					?>
					</select><br/>
					<h3>Select a Perspective:</h3>
					<select name="persp">
					<?php
					
					$rset = array();
					foreach($rels as $rl)
					{
						$rset[$rl->name] = $rl;
					}
					ksort($rset);
					
					echo '<optgroup label="By Relationship">';
					foreach($rset as $k => $v)
					{						
						echo '<option value="-'.$v->id.'"';
						if ($k == "Location") echo ' selected';
						echo '>'.$k.'</option>';
					}
					echo '</optgroup>';
					
					ksort($perspectives);
					
					echo '<optgroup label="By Value">';
					foreach($perspectives as $k => $v)
					{						
						echo '<option value="'.$v->id.'">'.$k.'</option>';
					}
					echo '</optgroup>';
					
					?>
					</select>
					<br/><br/>
					<button class="btn btn-success">Show Distribution</button>
					<?php
				
			ET();
		ET();
	ET();	
ET();

?>

<?php

?>
